VERSION 5.00
Begin VB.UserControl Shader 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4770
   Palette         =   "Shader.ctx":0000
   PaletteMode     =   1  'UseZOrder
   Picture         =   "Shader.ctx":0446
   ScaleHeight     =   238
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   318
   ToolboxBitmap   =   "Shader.ctx":088C
End
Attribute VB_Name = "Shader"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Shaded background control"
Option Explicit

' Enumerated values.
Enum shader_BorderStyle
    None_shader_BorderStyle = 0
    Fixed_Single_shader_BorderStyle = 1
End Enum

Enum shader_Direction
    Left_To_Right_shader_Direction
    Top_To_Bottom_shader_Direction
    UL_To_LR_shader_Direction
    LL_To_UR_shader_Direction
End Enum

'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
'Default Property Values:
Const m_def_Direction = Left_To_Right_shader_Direction
Const m_def_StartColor = vbBlue
Const m_def_EndColor = vbWhite
'Property Variables:
Dim m_Direction As Integer
Dim m_StartColor As OLE_COLOR
Dim m_EndColor As OLE_COLOR
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

' *********************************************
' Prepare the control's palette.
' *********************************************
Private Sub LoadPalette()
'Dim syspal_size As Integer
'Dim syspal As Long
'Dim num_static As Integer
'Dim static1 As Integer
'Dim static2 As Integer
'
'Dim palentry(0 To 255) As PALETTEENTRY
'Dim blanked(0 To 255) As PALETTEENTRY
'Dim i As Integer
'Dim r1 As Integer
'Dim g1 As Integer
'Dim b1 As Integer
'Dim r2 As Integer
'Dim g2 As Integer
'Dim b2 As Integer
'Dim r As Single
'Dim g As Single
'Dim b As Single
'Dim dr As Single
'Dim dg As Single
'Dim db As Single
'Dim num_colors As Integer
'
'    ' Get the system palette size.
'    syspal_size = GetDeviceCaps(hDC, SIZEPALETTE)
'    num_static = GetDeviceCaps(hDC, NUMRESERVED)
'    static1 = num_static \ 2 - 1
'    static2 = syspal_size - num_static \ 2
'
'    ' Make the form's palette as big as possible.
'    syspal = Picture.hPal
'    If ResizePalette(syspal, syspal_size) = 0 Then
'        Beep
'        MsgBox "Error resizing palette.", _
'            vbExclamation
'        Exit Sub
'    End If
'
'    ' Get the system palette entries.
'    i = GetSystemPaletteEntries(hDC, 0, syspal_size, palentry(0))
'
'    ' Blank the non-static colors.
'    For i = 0 To static1
'        blanked(i) = palentry(i)
'    Next i
'    For i = static1 + 1 To static2 - 1
'        With blanked(i)
'            .peRed = 0
'            .peGreen = 0
'            .peBlue = 0
'            .peFlags = PC_NOCOLLAPSE
'        End With
'    Next i
'    For i = static2 To 255
'        blanked(i) = palentry(i)
'    Next i
'    i = SetPaletteEntries(syspal, 0, syspal_size, blanked(0))
'
'    ' Prepare the non-static colors.
'    Color_to_RGB m_StartColor, r1, g1, b1
'    Color_to_RGB m_EndColor, r2, g2, b2
'    num_colors = static2 - static1 - 2
'    dr = (r2 - r1) / num_colors
'    dg = (g2 - g1) / num_colors
'    db = (b2 - b1) / num_colors
'    r = r1
'    g = g1
'    b = b1
'    For i = static1 + 1 To static2 - 1
'        palentry(i).peRed = r
'        palentry(i).peGreen = g
'        palentry(i).peBlue = b
'        palentry(i).peFlags = PC_NOCOLLAPSE
'        r = r + dr
'        g = g + dg
'        b = b + db
'    Next i
'    i = SetPaletteEntries(syspal, static1 + 1, static2 - static1 - 1, palentry(static1 + 1))
'
'    ' Realize the new palette values.
'    i = RealizePalette(hDC)
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As shader_BorderStyle
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As shader_BorderStyle)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

' *********************************************
' Break a color into its red, green, and blue
' components.
' *********************************************
Private Sub Color_to_RGB(color As Long, r As Integer, g As Integer, b As Integer)
    r = color Mod 256
    g = (color \ 256) Mod 256
    b = color \ 65536
End Sub

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_Paint()
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single
Dim dx As Single
Dim dy As Single
Dim r1 As Integer
Dim g1 As Integer
Dim b1 As Integer
Dim r2 As Integer
Dim g2 As Integer
Dim b2 As Integer
Dim r As Single
Dim g As Single
Dim b As Single
Dim dr As Single
Dim dg As Single
Dim db As Single

    Color_to_RGB m_StartColor, r1, g1, b1
    Color_to_RGB m_EndColor, r2, g2, b2

    Cls
    Select Case m_Direction
        Case Left_To_Right_shader_Direction
            dr = (r2 - r1) / (ScaleWidth + 1)
            dg = (g2 - g1) / (ScaleWidth + 1)
            db = (b2 - b1) / (ScaleWidth + 1)
            r = r1
            g = g1
            b = b1
            For x1 = 0 To ScaleWidth
                UserControl.Line (x1, 0)-(x1, ScaleHeight), RGB(r, g, b) + &H2000000
                r = r + dr
                g = g + dg
                b = b + db
            Next x1
        
        Case Top_To_Bottom_shader_Direction
            dr = (r2 - r1) / (ScaleHeight + 1)
            dg = (g2 - g1) / (ScaleHeight + 1)
            db = (b2 - b1) / (ScaleHeight + 1)
            r = r1
            g = g1
            b = b1
            For y1 = 0 To ScaleHeight
                UserControl.Line (0, y1)-(ScaleWidth, y1), RGB(r, g, b) + &H2000000
                r = r + dr
                g = g + dg
                b = b + db
            Next y1
        
        Case UL_To_LR_shader_Direction
            x2 = ScaleWidth + ScaleHeight
            dr = (r2 - r1) / (x2 + 1)
            dg = (g2 - g1) / (x2 + 1)
            db = (b2 - b1) / (x2 + 1)
            r = r1
            g = g1
            b = b1
            For x1 = 0 To x2
                UserControl.Line (0, x1)-(x1, 0), RGB(r, g, b) + &H2000000
                r = r + dr
                g = g + dg
                b = b + db
            Next x1
        
        Case LL_To_UR_shader_Direction
            x2 = ScaleWidth + ScaleHeight
            dr = (r2 - r1) / (x2 + 1)
            dg = (g2 - g1) / (x2 + 1)
            db = (b2 - b1) / (x2 + 1)
            r = r1
            g = g1
            b = b1
            For x1 = 0 To x2
                UserControl.Line (0, ScaleHeight - x1)-(x1, ScaleHeight), RGB(r, g, b) + &H2000000
                r = r + dr
                g = g + dg
                b = b + db
            Next x1
    
    End Select
End Sub
'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_StartColor = PropBag.ReadProperty("StartColor", m_def_StartColor)
    m_EndColor = PropBag.ReadProperty("EndColor", m_def_EndColor)
    m_Direction = PropBag.ReadProperty("Direction", m_def_Direction)

    LoadPalette
    UserControl_Paint
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("StartColor", m_StartColor, m_def_StartColor)
    Call PropBag.WriteProperty("EndColor", m_EndColor, m_def_EndColor)
    Call PropBag.WriteProperty("Direction", m_Direction, m_def_Direction)
End Sub

Public Property Get StartColor() As OLE_COLOR
Attribute StartColor.VB_Description = "The color to start drawing with."
    StartColor = m_StartColor
End Property

Public Property Let StartColor(ByVal New_StartColor As OLE_COLOR)
    m_StartColor = New_StartColor
    LoadPalette
    UserControl_Paint
    PropertyChanged "StartColor"
End Property

Public Property Get EndColor() As OLE_COLOR
Attribute EndColor.VB_Description = "The color to end drawing with."
    EndColor = m_EndColor
End Property

Public Property Let EndColor(ByVal New_EndColor As OLE_COLOR)
    m_EndColor = New_EndColor
    LoadPalette
    UserControl_Paint
    PropertyChanged "EndColor"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_StartColor = m_def_StartColor
    m_EndColor = m_def_EndColor
    m_Direction = m_def_Direction

    LoadPalette
    UserControl_Paint
End Sub

Public Property Get Direction() As shader_Direction
Attribute Direction.VB_Description = "The direction in which to shade."
    Direction = m_Direction
End Property

Public Property Let Direction(ByVal New_Direction As shader_Direction)
    m_Direction = New_Direction
    UserControl_Paint
    PropertyChanged "Direction"
End Property

